//+------------------------------------------------------------------+
//|                                                BarPercentage.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                                                  |
//|       Modified by Bernardo @ http://www.forexfactory.com/ber_tdf |
//+------------------------------------------------------------------+
#property  link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 0

extern int    TimeFrame = 0;
extern string FontName  = "Arial";
extern int    FontSize  = 9;
extern color  FontColor = Indigo;
extern int    Corner    = 1;// values [0-3] 
extern int    XDistance = 10;
extern int    YDistance = 10;

int lenbase;
string s_base=":...:...:...:...:";
string tName;

int init() {

   if (TimeFrame == 0) {
      TimeFrame = Period();
   }

   tName = "BarTimer#"+TimeFrame;

   return(0);
}

int deinit() {
   if (ObjectFind(tName) != -1) ObjectDelete(tName);
   return(0);
}

//+------------------------------------------------------------------+
int start() {
   int i=0,sec=0;
   double pc=0.0;
   string time="",s_end="",s_beg="";

   string s_base = timeFrameToString(TimeFrame) +  " :...:...:...:...:";

   lenbase = StringLen(s_base);

   if (ObjectFind(tName) == -1) {
     ObjectCreate(tName , OBJ_LABEL,0,0,0);
     ObjectSet(tName, OBJPROP_XDISTANCE, XDistance);
     ObjectSet(tName, OBJPROP_YDISTANCE, YDistance);
     ObjectSet(tName, OBJPROP_CORNER, Corner);
   }

   sec = TimeCurrent() - iTime(NULL, TimeFrame, 0);
   i = (lenbase-1) * sec / (TimeFrame * 60);
   pc = 100.0 * sec / (TimeFrame * 60);
   if (pc >= 99.5) pc = 99;
   if(i > lenbase-1) i = lenbase-1;
   if(i > 0) s_beg=StringSubstr(s_base, 0, i);
   if(i < lenbase-1) s_end = StringSubstr(s_base, i + 1, lenbase-i-1);
   time = StringConcatenate(s_beg, "|", s_end, "  ", DoubleToStr(pc, 0), "%");
   ObjectSetText(tName, time, FontSize, FontName, FontColor);
   
   return(0);
  }
//+------------------------------------------------------------------+

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs) {
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf) {
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

string stringUpperCase(string str) {
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--) {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}