//+------------------------------------------------------------------+
//|   #SpudFibo.mq4 - downloaded from ultimaforex.com                |
//|                                                                  |
//|       Modified by Bernardo @ http://www.forexfactory.com/ber_tdf |
//+------------------------------------------------------------------+
#property  indicator_chart_window

extern string note1 = "Fibonacci colors";
extern color UpperFiboColor = LightSkyBlue;
extern color MainFiboColor = PowderBlue;
extern color LowerFiboColor = LightSkyBlue;
extern string note2 = "Draw main Fibonacci lines?";
extern bool  InnerFibs = true;
extern string note3 = "Draw main Fibonacci Extension ?";
extern bool  UpFibs = false;
extern string note4 = "Draw main Fibonacci Retraccion ?";
extern bool  DwFibs = false;

double HiPrice, LoPrice, Range;
datetime StartTime;

int tBarTime;

string tFiboUp, tFiboDw, tFiboIn;

int init() {

   tFiboUp = "FiboUpDay";
   tFiboDw = "FiboDwDay";
   tFiboIn = "FiboInDay";

   tBarTime = iTime(NULL, PERIOD_D1, 1);
   return(0);
}

int deinit() {
   ObjectDelete(tFiboUp);
   ObjectDelete(tFiboDw);
   ObjectDelete(tFiboIn);
   tBarTime = iTime(NULL, PERIOD_D1, 1);
   return(0);
}

//+------------------------------------------------------------------+
//| Indicator start function
//+------------------------------------------------------------------+

int start() {

   if (Period() > PERIOD_H4) {
      return(0);
   }

   int tPeriod;

   if (tBarTime == iTime(NULL, PERIOD_D1, 0)) {
      return (0);
   }
   tBarTime = iTime(NULL, PERIOD_D1, 0);
   
   tPeriod = PERIOD_D1;
   
	int shift	= iBarShift(NULL, tPeriod, Time[0]) + 1;	// yesterday
	HiPrice		= iHigh(NULL, tPeriod, shift);
	LoPrice		= iLow (NULL, tPeriod, shift);
	StartTime	= iTime(NULL, tPeriod, shift);

	if(TimeDayOfWeek(StartTime)==0/*Sunday*/) { //Add fridays high and low
		HiPrice = MathMax(HiPrice,iHigh(NULL, tPeriod, shift+1));
		LoPrice = MathMin(LoPrice,iLow(NULL, tPeriod, shift+1));
	}

	Range = HiPrice - LoPrice;

	DrawFibo();

	return(0);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Draw Fibo
//+------------------------------------------------------------------+

int DrawFibo() {

   if (UpFibs == TRUE) {
	  if(ObjectFind(tFiboUp) == -1)
		  ObjectCreate(tFiboUp,OBJ_FIBO,0,StartTime,HiPrice+Range,StartTime,HiPrice);
	  else
	  {
		  ObjectSet(tFiboUp,OBJPROP_TIME2, StartTime);
		  ObjectSet(tFiboUp,OBJPROP_TIME1, StartTime);
		  ObjectSet(tFiboUp,OBJPROP_PRICE1,HiPrice+Range);
		  ObjectSet(tFiboUp,OBJPROP_PRICE2,HiPrice);
	  }
     ObjectSet(tFiboUp,OBJPROP_LEVELCOLOR,UpperFiboColor);
     ObjectSet(tFiboUp,OBJPROP_LEVELSTYLE,4);
     ObjectSet(tFiboUp,OBJPROP_FIBOLEVELS,12);
     ObjectSet(tFiboUp,OBJPROP_FIRSTLEVEL+0,0.236);	ObjectSetFiboDescription(tFiboUp,0,"(123.6%) - %$"); 
     ObjectSet(tFiboUp,OBJPROP_FIRSTLEVEL+1,0.382);	ObjectSetFiboDescription(tFiboUp,1,"(138.2%) - %$"); 
     ObjectSet(tFiboUp,OBJPROP_FIRSTLEVEL+2,0.500);	ObjectSetFiboDescription(tFiboUp,2,"(150.0%) - %$"); 
     ObjectSet(tFiboUp,OBJPROP_FIRSTLEVEL+3,0.618);	ObjectSetFiboDescription(tFiboUp,3,"(161.8%) - %$"); 
     ObjectSet(tFiboUp,OBJPROP_FIRSTLEVEL+4,0.886);	ObjectSetFiboDescription(tFiboUp,4,"(188.6%) - %$"); 
     ObjectSet(tFiboUp,OBJPROP_FIRSTLEVEL+5,1.000);	ObjectSetFiboDescription(tFiboUp,5,"(200.0%) - %$"); 
     ObjectSet(tFiboUp,OBJPROP_FIRSTLEVEL+6,1.236);	ObjectSetFiboDescription(tFiboUp,6,"(223.6%) - %$"); 
     ObjectSet(tFiboUp,OBJPROP_FIRSTLEVEL+7,1.500);	ObjectSetFiboDescription(tFiboUp,7,"(250.0%) - %$"); 
     ObjectSet(tFiboUp,OBJPROP_FIRSTLEVEL+8,1.618);	ObjectSetFiboDescription(tFiboUp,8,"(261.8%) - %$"); 
     ObjectSet(tFiboUp,OBJPROP_FIRSTLEVEL+9,2.000);	ObjectSetFiboDescription(tFiboUp,9,"(300.0%) - %$"); 
     ObjectSet(tFiboUp,OBJPROP_FIRSTLEVEL+10,2.500);	ObjectSetFiboDescription(tFiboUp,10,"(350.0%) - %$"); 
     ObjectSet(tFiboUp,OBJPROP_FIRSTLEVEL+11,3.000);	ObjectSetFiboDescription(tFiboUp,11,"(400.0%) - %$"); 
     ObjectSet(tFiboUp,OBJPROP_FIRSTLEVEL+12,3.500);	ObjectSetFiboDescription(tFiboUp,12,"(450.0%) - %$"); 
     ObjectSet(tFiboUp,OBJPROP_FIRSTLEVEL+13,4.000);	ObjectSetFiboDescription(tFiboUp,13,"(500.0%) - %$"); 
     ObjectSet(tFiboUp,OBJPROP_RAY,true);
     ObjectSet(tFiboUp,OBJPROP_BACK,true);
   }

   if (DwFibs == TRUE) {
	  if(ObjectFind(tFiboDw) == -1)
		  ObjectCreate(tFiboDw,OBJ_FIBO,0,StartTime,LoPrice-Range,StartTime,LoPrice);
	  else
	  {
		  ObjectSet(tFiboDw,OBJPROP_TIME2, StartTime);
		  ObjectSet(tFiboDw,OBJPROP_TIME1, StartTime);
		  ObjectSet(tFiboDw,OBJPROP_PRICE1,LoPrice-Range);
		  ObjectSet(tFiboDw,OBJPROP_PRICE2,LoPrice);
	  }
     ObjectSet(tFiboDw,OBJPROP_LEVELCOLOR,LowerFiboColor); 
     ObjectSet(tFiboDw,OBJPROP_LEVELSTYLE,4);
     ObjectSet(tFiboDw,OBJPROP_FIBOLEVELS,18);
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+0,0.236);	ObjectSetFiboDescription(tFiboDw,0,"(-23.6%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+1,0.382);	ObjectSetFiboDescription(tFiboDw,1,"(-38.2%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+2,0.500);	ObjectSetFiboDescription(tFiboDw,2,"(-50.0%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+3,0.618);	ObjectSetFiboDescription(tFiboDw,3,"(-61.8%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+4,0.886);	ObjectSetFiboDescription(tFiboDw,4,"(-88.6%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+5,1.000);	ObjectSetFiboDescription(tFiboDw,5,"(-100.0%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+6,1.236);	ObjectSetFiboDescription(tFiboDw,6,"(-123.6%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+7,1.382);	ObjectSetFiboDescription(tFiboDw,7,"(-138.2%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+8,1.500);	ObjectSetFiboDescription(tFiboDw,8,"(-150.0%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+9,1.618);	ObjectSetFiboDescription(tFiboDw,9,"(-161.8%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+10,1.886);	ObjectSetFiboDescription(tFiboDw,10,"(-188.6%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+11,2.000);	ObjectSetFiboDescription(tFiboDw,11,"(-200.0%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+12,2.500);	ObjectSetFiboDescription(tFiboDw,12,"(-250.0%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+13,3.000);	ObjectSetFiboDescription(tFiboDw,13,"(-300.0%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+14,3.500);	ObjectSetFiboDescription(tFiboDw,14,"(-350.0%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+15,4.000);	ObjectSetFiboDescription(tFiboDw,15,"(-400.0%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+16,4.500);	ObjectSetFiboDescription(tFiboDw,16,"(-450.0%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_FIRSTLEVEL+17,5.000);	ObjectSetFiboDescription(tFiboDw,17,"(-500.0%) - %$"); 
     ObjectSet(tFiboDw,OBJPROP_RAY,true);
     ObjectSet(tFiboDw,OBJPROP_BACK,true);
   }

	if(InnerFibs) {
		if(ObjectFind(tFiboIn) == -1)
			ObjectCreate(tFiboIn,OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_D1*60,LoPrice);
		else
		{
			ObjectSet(tFiboIn,OBJPROP_TIME2, StartTime);
			ObjectSet(tFiboIn,OBJPROP_TIME1, StartTime+PERIOD_D1*60);
			ObjectSet(tFiboIn,OBJPROP_PRICE1,HiPrice);
			ObjectSet(tFiboIn,OBJPROP_PRICE2,LoPrice);
		}
   	ObjectSet(tFiboIn,OBJPROP_LEVELCOLOR,MainFiboColor); 
      ObjectSet(tFiboIn,OBJPROP_LEVELSTYLE,3);
   	ObjectSet(tFiboIn,OBJPROP_FIBOLEVELS,7);
   	ObjectSet(tFiboIn,OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription(tFiboIn,0,"Day LOW (0.0) - %$"); 
   	ObjectSet(tFiboIn,OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription(tFiboIn,1,"(23.6) - %$"); 
   	ObjectSet(tFiboIn,OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription(tFiboIn,2,"(38.2) - %$"); 
   	ObjectSet(tFiboIn,OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription(tFiboIn,3,"(50.0) - %$"); 
   	ObjectSet(tFiboIn,OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription(tFiboIn,4,"(61.8) - %$"); 
   	ObjectSet(tFiboIn,OBJPROP_FIRSTLEVEL+5,0.886);	ObjectSetFiboDescription(tFiboIn,5,"(88.6) - %$"); 
   	ObjectSet(tFiboIn,OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription(tFiboIn,6,"Day HIGH (100.0) - %$"); 
   	ObjectSet(tFiboIn,OBJPROP_RAY,true);
   	ObjectSet(tFiboIn,OBJPROP_BACK,true);
   }
   else
	   ObjectDelete(tFiboIn);
}

